$fn=100;

module archedSensorShaft()
{
  shaftLength=12;
  socketDepth=1;
  axleRadius=3;
  slotWidth=2.8;
  archThickness=1.6;
  outerRadius=5;
  innerRadius=2;
  
  driverWidth=4;
  driverThickness=1;
  driverDepth=1.2;
  
  archAngle=30;
  
  union()
  {
    difference()
    {
      union()
      {
        intersection()
        {
          archShape();
          union()
          {
            cylinder(r=axleRadius, h=shaftLength+socketDepth);
            translate([0, -axleRadius, 0])
            {
              cube([outerRadius, 2*axleRadius, shaftLength+socketDepth]);
            }
          }
          cylinder(r=outerRadius, h=shaftLength+socketDepth);
        }
        intersection()
        {
          translate([0, -axleRadius, 0])
          {
            cube([axleRadius, 2*axleRadius, axleRadius*tan(archAngle)+socketDepth]);
          }
          cylinder(r=axleRadius, h=8);
        }
        cylinder(r=axleRadius, h=socketDepth);
      }
      
      translate([-axleRadius, -slotWidth/2, 3*socketDepth/2])
      {
        cube([outerRadius+axleRadius, slotWidth, shaftLength-socketDepth]);
      }
    }
    translate([-driverThickness/2, -driverWidth/2, shaftLength+socketDepth])
    {
      cube([driverThickness, driverWidth, driverDepth]);
    }
  }
  
//  module archOuter()
//  {
//    x0=0;
//    x1=outerRadius+axleRadius;
//    x2=axleRadius+driverThickness/2;
//    
//    y0=0;
//    y1=outerRadius*tan(archAngle);
//    y2=shaftLength-(outerRadius-driverThickness/2)*tan(archAngle);
//    y3=shaftLength;
//    
//    translate([-axleRadius, axleRadius, socketDepth-axleRadius*tan(archAngle)])
//    {
//      rotate([90, 0, 0])
//      {
//        linear_extrude(height=2*axleRadius)
//        {
//          polygon(points=[[x0, y0], [x1, y1], [x1, y2], [x2, y3], [x0, y3]], path=[0, 1, 2, 3, 4]);
//        }
//      }
//    }
//  }
//  
//  module archInner()
//  {
//    x0=0;
//    x1=outerRadius+axleRadius;
//    x2=axleRadius-driverThickness/2;
//    
//    y0=archThickness/cos(archAngle);
//    y1=y0+(outerRadius-archThickness)*tan(archAngle);
//    y2=shaftLength+(2*axleRadius+driverThickness/2)*tan(archAngle)-socketDepth-y1;
//    y3=shaftLength;
//  }
  
  
  module archShape()
  {
    x0=0;
    y0=socketDepth;
    
    x1=outerRadius;
    y1=y0+(x1-x0)*tan(archAngle);
    
    x3=archThickness/cos(90-archAngle)/2;
    y3=shaftLength+socketDepth;
    
    x2=x1;
    y2=y3-(x2-x3)*tan(archAngle);
    
    x4=-archThickness/cos(90-archAngle)/2;
    y4=y3;
    
    x5=innerRadius;//outerRadius-archThickness;
    y5=y3-(x5-x4)*tan(archAngle);
    
    x7=x0-archThickness/cos(90-archAngle);
    y7=socketDepth;
    
    x6=innerRadius;//outerRadius-archThickness;
    y6=(x6-x7)*tan(archAngle)+socketDepth;
    
    translate([0, axleRadius, 0])
    {
      rotate([90, 0, 0])
      {
        linear_extrude(height=2*axleRadius)
        {
          polygon(points=[[x0, y0], [x1, y1], [x2, y2], [x3, y3], [x4, y4], [x5, y5], [x6, y6], [x7, y7]], path=[0, 1, 2, 3, 4, 5, 6, 7]);
        }
      }
    }
  }
}
archedSensorShaft();