$fn=100;

module caseBottom()
{
  length=68;
  width=26;
  wallThickness=2.4;
  
  curveRadius=2.5;
  
  boltDistance=10.5;
  boltRadius=3.5;
  
  addendum=1.5;
  clearance=1.8;
  bigRadius=11;
  smallRadius=11/2;
  
  motorX=addendum+clearance+bigRadius;
  holder0X=motorX+2*bigRadius;
  holder1X=holder0X+bigRadius+smallRadius;
  
  
  slotWidth=6;
  holderDistance=addendum+clearance+(7*bigRadius+smallRadius)/2;
  slotLength=smallRadius+bigRadius;
  holderThickness=wallThickness;
  slotTolerance=0.4;
  
  cutoutWidth=16;
  
  difference()
  {
    union()
    {
      difference()
      {
        union()
        { 
          translate([0, 0, -3*wallThickness]) baseShape(true);
          translate([0, 0, -2*wallThickness]) baseShape(false);
          translate([0, 0, -wallThickness]) cube([length, width, wallThickness]);
        }
        translate([wallThickness, wallThickness, -2*wallThickness])
        {
          cube([length-2*wallThickness, width-2*wallThickness, 2*wallThickness]);
        }
        
        translate([motorX-cutoutWidth/2, 0, -wallThickness]) cube([cutoutWidth, width, wallThickness]);
        translate([holder0X-cutoutWidth/2, 0, -wallThickness]) cube([cutoutWidth, width, wallThickness]);
        
        translate([0, (width-cutoutWidth)/2, -wallThickness]) cube([2*motorX, cutoutWidth, wallThickness]);
      }
      
      translate([holderDistance, width/2, -2*wallThickness]) holderBlock();
    }
    translate([holderDistance, width/2, -2*wallThickness]) holderSlot();
  }
  
  module baseShape(endPiece)
  {
    offset_=2*(wallThickness-curveRadius);
    baseLength=length+offset_;
    baseWidth=width+offset_;
    barWidth=2*boltRadius+2*wallThickness+offset_;
    barLength=2*boltDistance+length+offset_;
    
    linear_extrude(height=wallThickness) difference()
    {
      union()
      {
        offset(r=-curveRadius) offset(2*curveRadius) union()
        {
          translate([-offset_/2, -offset_/2, 0]) square([baseLength, baseWidth]);
          if(endPiece)
          {
            translate([-boltDistance-offset_/2, (width-barWidth)/2, 0])
            {
              square([barLength, barWidth]);
            }
            translate([-boltDistance, width/2, 0]) circle(r=boltRadius+wallThickness+offset_/2);
            translate([length+boltDistance, width/2, 0]) circle(r=boltRadius+wallThickness+offset_/2);
          }
        }
      }
      translate([-boltDistance, width/2, 0]) circle(r=boltRadius);
      translate([length+boltDistance, width/2, 0]) circle(r=boltRadius);
    }
  }
  
  module holderBlock()
  {
    translate([0, 0, holderThickness/2])
    {
      cube([slotLength, slotWidth+2*wallThickness, holderThickness], center=true);
      cube([slotWidth+2*wallThickness, width, holderThickness], center=true);
    }
  }
  
  module holderSlot()
  {
    translate([0, 0, 3*holderThickness/2])
    {
      cube([slotLength, slotWidth+2*slotTolerance, 3*holderThickness], center=true);
      cube([slotWidth+2*slotTolerance, width+4*wallThickness, 3*holderThickness], center=true);
    }
  }
    
} 

caseBottom();