$fn=50;

module gearHolder()
{
  width=26+2*2.4;
  
  axleRadius=2.3;
  capRadius=2.0;
  
  smallGearRadius=5.5;
  largeGearRadius=11;
  tolerance=0.5;
  axleDistance=smallGearRadius+largeGearRadius+tolerance;
  
  axleHeight=38;
  capHeight=2.5;
  
  baseWidth=6.6;
  baseHeight=2.4;
  
  notchHeight1=14.4;
  notchHeight2=15;
  notchThickness=1.6;
  notchDepth=1.2;
  notchAngle=25;
  
  translate([axleDistance/2-baseWidth/2, -width/2, -baseHeight])
  {
  cube([baseWidth, width, baseHeight]);
  }
  
  difference()
  {
    union()
    {
      cylinder(r=axleRadius, h=axleHeight);
      translate([axleDistance, 0, 0]) cylinder(r=axleRadius, h=axleHeight);
      
      translate([0, 0, axleHeight]) cylinder(r1=axleRadius, r2=capRadius, h=capHeight);
      translate([axleDistance, 0, axleHeight]) cylinder(r1=axleRadius, r2=capRadius, h=capHeight);
      
      base(baseHeight, baseWidth, axleDistance);
    }
    translate([0, 0, notchHeight1]) notch();
    //translate([axleDistance, 0, notchHeight2]) notch();
  }
  
  module notch()
  {
    x0=0;
    x1=notchDepth;
    
    y0=notchThickness/2;
    y1=y0-x1*tan(notchAngle);
    
    translate([axleRadius-notchDepth, axleRadius, 0]) rotate([90, 0, 0]) linear_extrude(height=2*axleRadius)
    {
      polygon(points=[[x0, -y1], [x0, y1], [x1, y0], [x1, -y0]], paths=[[0, 1, 3], [3, 1, 2]]);
    }
  }
}

module base(baseHeight, baseWidth, axleDistance)
{
  translate([0, 0, -baseHeight])
  {
      cylinder(r=baseWidth/2, h=baseHeight);
      
      translate([0, -baseWidth/2, 0])
      {
        cube([axleDistance, baseWidth, baseHeight]);
      }
      
      translate([axleDistance, 0, 0])
      {
        cylinder(r=baseWidth/2, h=baseHeight);
      }
  }
}

gearHolder();
