include <gearLibrary.scad>;

$fn=200;

module standardGear()
{
    topGearThickness=6;
    bottomGearThickness=2;
    
    topGearPitch=5.5;
    bottomGearPitch=11;
    
    topGearTeeth=6;
    bottomGearTeeth=12;
    
    axleRadius=2.6;
    
    modifier=0.1;
    innerRadius=axleRadius-modifier;
        
    pressureAngle=15;
    
    addendumTolerance=0.1*bottomGearPitch;
    dedendumTolerance=0.5;
    
    addendum=addendumCalc(topGearPitch, pressureAngle, topGearTeeth, bottomGearTeeth)+addendumTolerance;
    dedendum=addendumCalc(bottomGearPitch, pressureAngle, bottomGearTeeth, topGearTeeth);
    
    echo(addendum, dedendum);
    
    difference()
    {
        union()
        {
            gear(bottomGearPitch, pressureAngle, bottomGearTeeth, dedendum, addendum+dedendumTolerance, bottomGearThickness, 0, 0.1);
            
            translate([0, 0, bottomGearThickness])
            {
                gear(topGearPitch, pressureAngle, topGearTeeth, addendum, dedendum+dedendumTolerance, topGearThickness, 0, 0.1);
            }
        }
        
        cylinder(r=innerRadius, h=bottomGearThickness+topGearThickness);
    }
}

standardGear();