include <gearLibrary.scad>;

$fn=200;

module motorGear()
{
    gearThickness=3;
    
    topGearPitch=5.5;
    bottomGearPitch=11;
    
    topGearTeeth=6;
    bottomGearTeeth=12;
    
    axleRadius=2.5;
    
    innerRadius=0.98;
        
    pressureAngle=15;
    backLash=0.2;
    
    addendumTolerance=0.1*bottomGearPitch;
    dedendumTolerance=0.5;
    
    addendum=addendumCalc(topGearPitch, pressureAngle, topGearTeeth, bottomGearTeeth)+addendumTolerance;
    dedendum=addendumCalc(bottomGearPitch, pressureAngle, bottomGearTeeth, topGearTeeth);
    
    echo(addendum, dedendum);
    
    difference()
    {
        gear(bottomGearPitch, pressureAngle, bottomGearTeeth, dedendum, addendum+dedendumTolerance, gearThickness, backLash, 0.1);
        
        cylinder(r=innerRadius, h=gearThickness);
    }
}

motorGear();