$fn=50;

include <threadExp.scad>;

module adjustmentLock()
{
    height=3;
    pitch=1.5;
    
    threadTolerance=0.3;
    pitchRadius=6.2+threadTolerance;
    pitchAngle=30;
    
    addendum=pitch/(8*tan(pitchAngle))-0.1;
    dedendum=addendum*4-0.2;
    
    outerWidth=26;
    
    apothem=outerWidth*cos(360/12)/2;
    
    difference()
    {
        hex(apothem, height);
        
        thread(pitch, pitchRadius, pitchAngle, addendum, dedendum, height, $fn, 1);
    }
}

module hex(apothem, height)
{
    for(i=[0:2])
    {
        rotate([0, 0, i*360/3])
        {
            translate([-apothem, -tan(360/12)*apothem, 0])
            {
                cube([2*apothem, tan(360/12)*2*apothem, height]);
            }
        }
    }
}

adjustmentLock();
