$fn=30;

include <threadExp.scad>;

module caseScrew()
{
    wallThickness=2.4;
    
    pitchAngle=30;
    pitch=1.5;
    
    pitchRadius=2.8;
    
    addendumTolerance=0.2;
    
    addendum=pitch/(4*tan(pitchAngle))-addendumTolerance;
    dedendum=addendum;
    
    caseHeight=53;
    holderHeight=2;
    
    lockNutHeight=3;
    
    threadHeight=4*wallThickness;
    
    shaftHeight=caseHeight+holderHeight+lockNutHeight-wallThickness;
    
    hexApothem=4.4/2;
    
    headHeight=4;
    headRadius=pitchRadius+2*wallThickness;
    
    difference()
    {
        union()
        {
            translate([0, 0, headHeight])
            {
                cylinder(r=pitchRadius+addendum, h=shaftHeight);
            }
            
            translate([0, 0, headHeight+shaftHeight])
            {
                thread(pitch, pitchRadius, pitchAngle, addendum, dedendum, threadHeight, $fn, 1);
            }
            
            hex(headRadius*cos(360/12), headHeight);
        }
        
        hex(hexApothem, wallThickness);
    }
}

module hex(apothem, height)
{
    for(i=[0:2])
    {
        rotate([0, 0, i*360/3])
        {
            translate([-apothem, -tan(360/12)*apothem, 0])
            {
                cube([2*apothem, tan(360/12)*2*apothem, height]);
            }
        }
    }
}

caseScrew();
