$fn=50;

include <threadExp.scad>;

module screwLock()
{
    wallThickness=2.4;
    height=wallThickness;
    pitch=1.5;
    
    pitchAngle=30;
    
    addendumTolerance=0.2;
    
    addendum=pitch/(4*tan(pitchAngle))-addendumTolerance;
    dedendum=addendum;
    
    threadTolerance=0.5;
    pitchRadius=2.8+threadTolerance;
    
    outerWidth=26;
    
    apothem=(pitchRadius+2*wallThickness)*cos(360/12);
    
    difference()
    {
        hex(apothem, height);
        
        thread(pitch, pitchRadius, pitchAngle, addendum, dedendum, height, $fn, 1);
    }
}

module hex(apothem, height)
{
    for(i=[0:2])
    {
        rotate([0, 0, i*360/3])
        {
            translate([-apothem, -tan(360/12)*apothem, 0])
            {
                cube([2*apothem, tan(360/12)*2*apothem, height]);
            }
        }
    }
}

screwLock();
