$fn=100;

module spacerClip()
{
  clipThickness=1.5;
  slotThickness=0.75;
  slotDepth=1.2;
  
  border=0.82;
  
  length=24;
  grooveThickness=2;
  endRadius=border+grooveThickness/2;
  
  innerRadius=2.1;
  outerRadius=2.8;
  
  halfPiece(false);
  rotate([0, 0, 180]) halfPiece(true);
  
  module halfPiece(slot)
  {
    intersection()
    {
      difference()
      {
        union()
        {
          translate([innerRadius-outerRadius, 0, 0]) difference()
          {
            union()
            {
              cylinder(r=outerRadius+border, h=clipThickness);
              translate([outerRadius-innerRadius, 0, 0]) hull()
              {
                translate([0, length/2-endRadius, 0]) cylinder(r=endRadius, h=clipThickness);
                translate([0, endRadius-length/2, 0]) cylinder(r=endRadius, h=clipThickness);
              }
            }
            cylinder(r=outerRadius, h=clipThickness);
          }
          if(slot==true)
          {
            intersection()
            {
              cylinder(r=outerRadius, h=slotThickness);
              translate([innerRadius-slotDepth, -outerRadius, 0])
              {
                cube([slotDepth, 2*outerRadius, slotThickness]);
              }
            }
          }
        }
        translate([0, grooveThickness/2+border-length/2, 0])
        {
          cube([grooveThickness/2, length-2*(border+grooveThickness/2), clipThickness]);
          cylinder(r=grooveThickness/2, h=clipThickness);
          translate([0, length-2*(border+grooveThickness/2), 0]) cylinder(r=grooveThickness/2, h=clipThickness);
        }
      }
      translate([0, -length/2, 0]) cube([outerRadius+border, length, clipThickness]);
    }
  }
}

spacerClip();
