$fn=50;

include <threadExp.scad>;

module threadedPlate()
{
    outerWidth=20.4;
    
    threadTolerance=0.3;
    pitchRadius=6.2+threadTolerance;
    pitchAngle=30;
    
    plateThickness=1.8;
    cubeHeight=1.8;
    
    threadPitch=1.5;
    
    plateWidth=24;
    
    threadHeight=2*threadPitch+plateThickness+cubeHeight;
    
    addendumTolerance=0.2;
    
    addendum=threadPitch/(8*tan(pitchAngle))-addendumTolerance;
    dedendum=addendum*4;
    
    difference()
    {
        union()
        {
            translate([-plateWidth/2, -plateWidth/2, 0])
            {
                cube([plateWidth, plateWidth, plateThickness]);
            }
            
            translate([-outerWidth/2, -outerWidth/2, 0])
            {
                cube([outerWidth, outerWidth, cubeHeight+plateThickness]);
            }
        }
        
        translate([0, 0, -threadPitch])
        {
            thread(threadPitch, pitchRadius, pitchAngle, addendum, dedendum, threadHeight, $fn, 1);
        }
    }
}

threadedPlate();
